<script setup lang="ts">
import {onMounted, ref, watch} from "vue";
import Repository from "@/entities/Repository/Repository";
import {useRoute, useRouter} from "vue-router";
import RepositoryFixtures from "@/fixtures/RepositoryFixtures";
import TwoSectionTemplate from "@/components/templates/TwoSectionTemplate.vue";
import RepositoryPresentationSection from "@/components/pages/Repository/show/RepositoryPresentationSection.vue";
import RepositoryTabsSection from "@/components/pages/Repository/show/RepositoryTabsSection.vue";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";

const repository = ref<Repository | null>(null);

const route = useRoute();
const router = useRouter();

const repositoryHandler = new RepositoryApiHandler();

const searchRepository = () => {
  const code = route.params.code;
  repositoryHandler
      .find(code)
      .then((repo: Repository) => repository.value = repo)
      .catch(() => {
        const repo = RepositoryFixtures.find((repo: Repository) => repo.code === code);

        if (!repo) {
          router.push('/404');
          return;
        }

        repository.value = repo;
      });
}


watch(() => route.params.code, searchRepository);
onMounted(searchRepository)
</script>

<template>
  <TwoSectionTemplate v-if="repository instanceof Repository">
    <template #left>
      <RepositoryPresentationSection :repository="repository"/>
    </template>
    <RepositoryTabsSection :repository="repository"/>
  </TwoSectionTemplate>
</template>
